// -*- Mode: C++ -*-

// ----------------------------------------------------------------------------
//  cab_arc.h
// ----------------------------------------------------------------------------

#ifndef cab_arc_h__
#define cab_arc_h__

// ----------------------------------------------------------------------------
//  CN[h
// ----------------------------------------------------------------------------

#include "spi_misc.h"


// ----------------------------------------------------------------------------
//  cabinet A[JCu
// ----------------------------------------------------------------------------

class cab_archive
{
  class cab_decompressor  *m_cab_dec;
  class cab_file  *m_cab_file;
  uint  m_file_num;
  bool  m_skipped;

  void to_fileinfo(fileInfo *fi, const class cab_file *file);

public:
  cab_archive(void)
       : m_cab_dec(NULL),
         m_cab_file(NULL) { }
  ~cab_archive() { close_archive(); }

  int open_archive(const char *arc_name);
  void close_archive(void);
  int get_next_fileinfo(fileInfo *fi);
  int extract(uint8 *buf, size_t buf_size, spi_callback *spicb);

  static int is_cabinet(const uint8 *buf);
  static int is_cabinet_sfx(HANDLE fh);
};


#endif // cab_arc_h__
