// -*- Mode: C++ -*-

// ----------------------------------------------------------------------------
//  seq_num.h
// ----------------------------------------------------------------------------

#ifndef seq_num_h__
#define seq_num_h__

// ----------------------------------------------------------------------------
//  CN[h
// ----------------------------------------------------------------------------

#include "crit_sec.cxx"


// ----------------------------------------------------------------------------
//  seq_num_generator
// ----------------------------------------------------------------------------

class seq_num_generator : public critical_section
{
  static seq_num_generator *m_inst;

  unsigned int  m_num;

  seq_num_generator(void)
       : m_num(0) { }
  ~seq_num_generator() { }

public:
  static seq_num_generator *get_instance(void)
  {
    try {
      if (NULL == m_inst)
        m_inst = new seq_num_generator;
    } catch (...) {
      m_inst = NULL;
    }
    return m_inst;
  }

  unsigned int generate(void)
  {
    enter();
    unsigned int  ret_num = m_num++;
    leave();
    return ret_num;
  }
};


#endif // seq_num_h__
