// -*- Mode: C++ -*-

// ----------------------------------------------------------------------------
//  spi_misc.h
// ----------------------------------------------------------------------------

#ifndef spi_misc_h__
#define spi_misc_h__

// ----------------------------------------------------------------------------
//  CN[h
// ----------------------------------------------------------------------------

#include "conf.h"
#include "spi.h"


// ----------------------------------------------------------------------------
//  vg^Cv錾
// ----------------------------------------------------------------------------

int is_file_in(uint flags);
int is_file_out(uint flags);
int is_ignore_case(uint flags);


// ----------------------------------------------------------------------------
//  spi ̃R[obN
// ----------------------------------------------------------------------------

class spi_callback
{
  SPI_CALLBACK  m_callback_func;
  long  m_data;
  int  m_num, m_denom;

public:
  spi_callback(SPI_CALLBACK func, long data)
       : m_callback_func(func),
         m_data(data) { }
  ~spi_callback() { }

  void set_demon(int denom)
  {
    m_num = 0;
    m_denom = denom;
  }

  int notify(int d)
  {
    m_num += d;
    return (NULL != m_callback_func) ?
      m_callback_func(m_num, m_denom, m_data) : 0;
  }
};


#endif // spi_misc_h__
